Page MenuHomePhabricator

Perform a technical debt analysis of software and services maintained by WMF Release Engineering
Closed, ResolvedPublic

Description

Analysis documents

Technical Debt analysis plan / what happened

Working meeting #1 (50minutes, date/time: June 30th at 9am Pacific):

Working meeting #2 (80 minutes, date/time: July 6th at 9am Pacific):

  • Identify all associated "technical debt" things in each criteria category (55 minutes)
  • Review all related incident reports for incomplete tasks (20 minutes)

Team meetings discussion about insufficiencies in the process July 18th and 25th

  • Mega spreadsheet wasn't a good entry point for dealing with this
    • "Redux" and then "Redux Redux" versions made.

Fill out "Redux Redux" sheet (week of August 1st)

  • done

Identify hot-spots (week of August 8th)

  1. release tooling" (which included "MW 3rd party releases", "l10nupdate", and will probably include any "swat deploy tooling" to address process tech debt)
  2. CI/Nodepool

Next steps

  • Make changes to quarterly goals as appropriate (emphasizing the identified tech debt)

Event Timeline

greg created this task.Jun 20 2016, 3:06 PM
Restricted Application added subscribers: Zppix, Aklapper. · View Herald TranscriptJun 20 2016, 3:06 PM
greg updated the task description. (Show Details)Jun 20 2016, 11:13 PM
greg updated the task description. (Show Details)
greg moved this task from Backlog to Next on the User-greg board.
greg updated the task description. (Show Details)Jun 21 2016, 10:47 PM
greg updated the task description. (Show Details)Jun 22 2016, 7:08 AM
greg updated the task description. (Show Details)Jun 22 2016, 7:11 AM
greg moved this task from Next to In Progress on the User-greg board.Jun 22 2016, 6:01 PM
hashar added a subscriber: hashar.Jun 28 2016, 8:06 AM

I have filled a bunch that are related to CI/beta cluster.

greg updated the task description. (Show Details)Jun 28 2016, 10:32 PM
greg updated the task description. (Show Details)
faidon added a subscriber: faidon.Jul 26 2016, 2:49 PM
greg added a subscriber: dduvall.Jul 26 2016, 3:52 PM

Quick status update: Upon @dduvall's return and digging into this plan he identified practical issues and made helpful recommendations/changes, as he does. Identification of problem areas (the intersection of software/services we maintain and types of problem areas (eg: bus factor, ease of upgrading, etc) will be done by end of week (July 29th). After that we’ll dig into those problem areas and identify (more) specific problems and remediation plans. ETA still end of quarter.

greg added a comment.Aug 8 2016, 8:37 PM

Based on the updated process proposed by @dduvall we've identified the broad category of "release tooling" (which included "MW 3rd party releases", "l10nupdate", and will probably include any "swat deploy tooling" to address process tech debt). Additionally, CI/nodepool was identified as another on-going area in need of analysis.

Analysis and plan of action for those areas are the next steps.

greg updated the task description. (Show Details)Aug 19 2016, 11:10 PM

From our weekly team meeting, @dduvall mentioned we had a tendency to start new things without fully completing past work. The few migrations we had to conduct (nodepool, scap3, differential) exacerbate that.

We quickly talked about setting up quarterly goals solely dedicated to resorbing the backlog so we can regain dynamic in the next quarters.

greg closed this task as Resolved.Sep 1 2016, 10:33 PM
greg claimed this task.

Documented, goals/plans changed for next quarter. Calling this part done. On-going addressing of tech debt will be... on-going.